 package edu.vub.crime;

import java.util.Properties;

import junit.framework.TestCase;
import edu.vub.crime.rete.agenda.InlineScheduler;
import edu.vub.crime.rete.nodes.RootNode;

/**
 * This class implements convenience methods to be used when implementing CRIME unit tests.
 * 
 * @author smostinc
 */
public abstract class CrimeTestCase extends TestCase {
	
	protected CrimeEngine		  itsEngine;
	protected RootNode   		itsRootNode;
	protected InlineScheduler  itsScheduler;
	
	/**
	 * This protected constructor ensures that the classes that are tested by the standard suite
	 * of unit tests use the default Crime engine without any network interface.
	 */
	protected CrimeTestCase() {
		Properties theClassesUnderTest = CrimeFactory.factoryClasses;
		
		theClassesUnderTest.setProperty("Engine",		"edu.vub.crime.CrimeEngine");
		theClassesUnderTest.setProperty("Memory",		"edu.vub.crime.memory.LocalMemory");
		theClassesUnderTest.setProperty("Network",		"edu.vub.crime.network.NetworkLayer");
		theClassesUnderTest.setProperty("Agenda",		"edu.vub.crime.rete.agenda.FIFOAgenda");
		theClassesUnderTest.setProperty("Scheduler",	"edu.vub.crime.rete.agenda.InlineScheduler");
		
		itsEngine		= CrimeFactory.createEngine();
		itsRootNode		= itsEngine.itsRootNode;
		itsScheduler	= (InlineScheduler) itsEngine.itsScheduler;

	}
}
