package edu.vub.crime.aux;

import edu.vub.crime.CrimeEngine;
import edu.vub.crime.rete.agenda.Agenda;
import edu.vub.crime.rete.agenda.InlineScheduler;
import edu.vub.crime.rete.agenda.ThreadedScheduler;


/** 
 * A scheduler executes the activations that are scheduled in the Rete engine's {@link Agenda}.
 * This particular scheduler starts its own thread and will thus process activations in
 * parallel to any concurrent processes.
 * 
 * @see InlineScheduler which allows programmer control over when activations are processed.
 * 
 * @author smostinc
 */
public class SlowerScheduler extends ThreadedScheduler {

	public SlowerScheduler(Agenda theAgenda, CrimeEngine theEngine) {
		super(theAgenda, theEngine);
	}

	public void loopBody() {
   		super.loopBody();
   		
   		try {
			synchronized(this) { this.wait(300); }
		} catch (InterruptedException e) { }
	}
}
