package edu.vub.crime.dataflow;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.vub.crime.CrimeEngine;
import edu.vub.crime.grammar.attributes.datastructures.Operator;
import edu.vub.crime.rete.filter.FilterAttribute;
import edu.vub.crime.rete.nodes.FilterNode;

public class FilterFlow extends FilterAttribute implements ActionListener {

	private final DataFlowAttribute itsFlow;
	private final FilterNode 		itsNode;
	private final CrimeEngine 		itsEngine;
	
	public FilterFlow(DataFlowAttribute theFlow, Operator filterComparison, FilterNode theNode, CrimeEngine theEngine) {
		super(theFlow.getCurrentValue(), filterComparison);
		
		itsFlow		= theFlow;
		itsNode		= theNode;
		itsEngine	= theEngine;
		
		theFlow.subscribe(this);
	}

	public void actionPerformed(ActionEvent e) {
		itsFilterAttribute = itsFlow.getCurrentValue();
		
		// To avoid concurrency issues, we cannot ask the filter node to reevaluate itself directly. 
		// Doing so would permit different processes to manipulate the rete network simultaneously.
		// Therefore we schedule a dedicated activation to be processed by the engine's scheduler.
		itsEngine.getAgenda().schedule(new FilterReevaluation(itsNode));
	}
}
