/**
 * 
 */
package edu.vub.crime.exceptions;

import edu.vub.crime.grammar.attributes.Attribute;
import edu.vub.crime.grammar.attributes.CompoundAttribute;

/**
 * Instances of this class are thrown whenever an Attribute is indexed with an incorrect index expression. 
 * 
 * @author smostinc
 */
public class IncorrectAttributeIndexException extends CrimeException {

	private final Object	theNextIndex;
	private final Attribute	theAttribute;
	
	public IncorrectAttributeIndexException(Object anIndex, Attribute anAttribute) {
		theNextIndex = anIndex;
		theAttribute = anAttribute;
	}
		
	public String getMessage() {
		if(theAttribute instanceof CompoundAttribute) {
			return "Compound attribute " + theAttribute + "does not have a member with index " + theNextIndex; 
		} else {
			return "Cannot futher index the attribute " + theAttribute;
		}
	}
}
