package edu.vub.crime.grammar;

import java.util.Set;

import edu.vub.crime.grammar.attributes.Attribute;
import edu.vub.crime.grammar.attributes.Variable;
import edu.vub.crime.grammar.attributes.datastructures.Operator;

public class Constraint extends Primitive {
	private Variable 	itsVariable;
	private Operator 	itsConstraint;
	private Attribute	itsExpectedValue;

	public Constraint(Variable variable, Operator constraint, Attribute value){
		itsVariable			= variable;
		itsConstraint		= constraint;
		itsExpectedValue	= value;
	}

	public String toString(){
        return itsVariable.toString() + itsConstraint.toString()+ itsExpectedValue.toString();
 	}
	
	public void validate(Set variables){
		if(!(variables.contains(itsVariable)))
			throw new RuntimeException("Unbound variable "+ itsVariable); 
	}

	public void accept(GrammarVisitor visitor) {
		visitor.visit(this);
	}

	public Variable getVariable() {
		return itsVariable;
	}

	public Operator getConstraint() {
		return itsConstraint;
	}

	public Attribute getExpectedValue() {
		return itsExpectedValue;
	}
}
