package edu.vub.crime.grammar;

import edu.vub.crime.Action;
import edu.vub.crime.CrimeEngine;
import edu.vub.crime.util.Logging;

public class LiteralEvent extends Event {

	public LiteralEvent(String theClassName) {
		super(theClassName);
	}
	
	/** 
	 * Loads the given action class and instantiates it upon initialization.
	 */
	public void initialize(CrimeEngine itsEngine, ExpressionList expressions) {
		String theClassName = ExpressionFactory.resolveAbbreviation(kind_);
		
		Class actionClass;
		try {
			if(CrimeEngine.PACKAGE_DECL == null || theClassName != kind_ || kind_.indexOf('.') > 0)
				actionClass = Class.forName(theClassName);
			else
				actionClass = Class.forName(CrimeEngine.PACKAGE_DECL+"."+theClassName);
			
			this.action_ = (Action) actionClass.newInstance();
			
			super.initialize(itsEngine, expressions);
					
		} catch (Exception e) {
			Logging.Engine_LOG.error("Error loading event class", e);
		}
	}
	
	public String toString() {
		return itsRepresentation.toString();
	}
}
