package edu.vub.crime.grammar.attributes;

import edu.vub.crime.dataflow.DataFlowAttribute;
import edu.vub.crime.grammar.attributes.constant.*;
import edu.vub.crime.grammar.attributes.constant.Number;
import edu.vub.crime.grammar.attributes.datastructures.*;


public class AttributeVisitor {

	private final String itsPurpose;
	private final String itsModality;

	public AttributeVisitor(String thePurpose, String theModality) {
		itsPurpose = thePurpose;
		itsModality = theModality;
	}
	
	private static final String getSimpleName(Class c) {
		String nam = c.getName();
		return nam.substring(nam.lastIndexOf(".") + 1);
	}
	
	private final void visit(Attribute theAttribute) { 
		throw new RuntimeException("Cannot " + itsPurpose + " a " + getSimpleName(theAttribute.getClass()) + " attribute" + itsModality + "."); 
	};
		
	protected void visit(ConstantAttribute theAttribute) { visit((Attribute) theAttribute); }
	
	public void visit(Fraction theFraction) { visit((ConstantAttribute) theFraction); };
	public void visit(Number theNumber) 	{ visit((ConstantAttribute) theNumber); };
	public void visit(Symbol theSymbol) 	{ visit((ConstantAttribute) theSymbol); };
	public void visit(Text theText) 		{ visit((ConstantAttribute) theText); };
	public void visit(Type theType) 		{ visit((ConstantAttribute) theType); };

	
	public void visit(List theList) { throw new RuntimeException("Cannot " + itsPurpose + " a List attribute" + itsModality + "."); };
	public void visit(Pair thePair) { throw new RuntimeException("Cannot " + itsPurpose + " a Pair attribute" + itsModality + "."); };
	public void visit(Variable theVariable) { throw new RuntimeException("Cannot " + itsPurpose + " a Variable attribute" + itsModality + "."); };

	public void visit(TypedObject theTypedObject) { throw new RuntimeException("Cannot " + itsPurpose + " a TypedObject attribute" + itsModality + "."); };
	public void visit(DataFlowAttribute theFlow) { throw new RuntimeException("Cannot " + itsPurpose + " a DataFlow attribute" + itsModality + "."); };
}
