package edu.vub.crime.grammar.attributes;

import junit.framework.TestCase;
import edu.vub.crime.grammar.ExpressionFactory;

public class ConstantAttributeTest extends TestCase {

	private void assertNotEquals(Object expected, Object actual) {
		assertFalse(expected.equals(actual));
	}
	
	public void testEqualityConversion() {
		Attribute FRC_ZERO = ExpressionFactory.attribute(0.0);
		Attribute NUM_ZERO = ExpressionFactory.attribute(0);
		Attribute TXT_ZERO = ExpressionFactory.attribute("0");
		Attribute SYM_ZERO = ExpressionFactory.symbol("0");
		Attribute TYP_ZERO = ExpressionFactory.type("0");
		
		assertEquals(NUM_ZERO, FRC_ZERO);
		assertEquals(FRC_ZERO, NUM_ZERO);

		assertNotEquals(NUM_ZERO, TXT_ZERO);
		assertNotEquals(TXT_ZERO, NUM_ZERO);
		assertNotEquals(FRC_ZERO, TXT_ZERO);
		assertNotEquals(TXT_ZERO, FRC_ZERO);
		
		assertNotEquals(SYM_ZERO, TXT_ZERO);
		assertNotEquals(TXT_ZERO, SYM_ZERO);
		assertNotEquals(TYP_ZERO, TXT_ZERO);
		assertNotEquals(TXT_ZERO, TYP_ZERO);
		assertNotEquals(SYM_ZERO, TYP_ZERO);
		assertNotEquals(TYP_ZERO, SYM_ZERO);

	}
}
