package edu.vub.crime.grammar.attributes.constant;

import edu.vub.crime.grammar.ExpressionFactory;
import edu.vub.crime.grammar.attributes.Attribute;
import edu.vub.crime.grammar.attributes.AttributeVisitor;
import edu.vub.crime.grammar.attributes.ConstantAttribute;

/** 
 * Numeric attribute which holds a non-decimal number. It is possible to compare
 * such numbers with a fractional number.
 */
public class Number extends ConstantAttribute {
	
	private final int itsValue;
	
	public Number(int aNumber)						{ itsValue = aNumber; }
	public int getValue()							{ return itsValue; }
	public String toString() 						{ return Integer.toString(itsValue); }
	public void accept(AttributeVisitor theVisitor) { theVisitor.visit(this); }

	public boolean equals(Object anotherObject) {
		if(anotherObject instanceof Number)
			return itsValue == ((Number)anotherObject).getValue();
		
		if(anotherObject instanceof Fraction)
			return itsValue == ((Fraction)anotherObject).getValue();
		
		return false;
	}
	
	public Object clone() {		
		 Attribute theClone = ExpressionFactory.attribute(itsValue);
		 cloneIndexFor(theClone);
		 return theClone;
	}
}