package edu.vub.crime.grammar.attributes.constant;

import edu.vub.crime.grammar.ExpressionFactory;
import edu.vub.crime.grammar.attributes.Attribute;
import edu.vub.crime.grammar.attributes.AttributeVisitor;
import edu.vub.crime.grammar.attributes.ConstantAttribute;

/**
 * @author smostinc
 *
 */
public class Symbol extends ConstantAttribute {
	
	private final String itsValue;
	
	public Symbol(String aSymbol)					{ itsValue = aSymbol; }
	public String getValue()						{ return itsValue; }
	public String toString() 						{ return "`" + itsValue; }
	public void accept(AttributeVisitor theVisitor) { theVisitor.visit(this); }

	public boolean equals(Object anotherObject) {
		if (anotherObject instanceof Symbol) {
			Symbol anotherSymbol = (Symbol) anotherObject;
			
			return itsValue.equals(anotherSymbol.getValue());
		}
		
		return false;
	}
	
	public Object clone() {		
		 Attribute theClone = ExpressionFactory.symbol(itsValue);
		 cloneIndexFor(theClone);
		 return theClone;
	}
}
