package edu.vub.crime.grammar.attributes.constant;

import edu.vub.crime.grammar.ExpressionFactory;
import edu.vub.crime.grammar.attributes.Attribute;
import edu.vub.crime.grammar.attributes.AttributeVisitor;
import edu.vub.crime.grammar.attributes.ConstantAttribute;

/**
 * @author smostinc
 *
 */
public class Text extends ConstantAttribute {
	
	private final String itsValue;
	
	public Text(String aSymbol)						{ itsValue = aSymbol; }
	public String getValue()						{ return itsValue; }
	public String toString() 						{ return "\"" + itsValue + "\""; }
	public void accept(AttributeVisitor theVisitor) { theVisitor.visit(this); }

	public boolean equals(Object anotherObject) {
		if (anotherObject instanceof Text) {
			Text anotherSymbol = (Text) anotherObject;
			
			return itsValue.equals(anotherSymbol.getValue());
		}
		
		return false;
	}
	
	public Object clone() {		
		 Attribute theClone = ExpressionFactory.attribute(itsValue);
		 cloneIndexFor(theClone);
		 return theClone;
	}
}
