/**
 * 
 */
package edu.vub.crime.grammar.attributes.constant;

import edu.vub.crime.grammar.ExpressionList;
import edu.vub.crime.grammar.attributes.AttributeVisitor;
import edu.vub.crime.grammar.attributes.ConstantAttribute;
import edu.vub.crime.grammar.utils.AttributePicker;
import edu.vub.crime.grammar.utils.UtilsFactory;

/**
 * @author smostinc
 *
 */
public class Type extends ConstantAttribute {

	private final String theTypeName;
	private final Type[] theParentTypes;
	
	public Type(String aName, Type[] allParentTypes) {
		theTypeName		= aName;
		theParentTypes	= allParentTypes;
	}
	
	public Object clone() { return new Type(theTypeName, theParentTypes); }
	
	public boolean equals(Object possibleTypeAttribute) {
		if(possibleTypeAttribute instanceof Type) {
			Type anotherTypeAttribute = (Type) possibleTypeAttribute;
			
			return isSubTypeOf(anotherTypeAttribute);
		}
		return false;
	}
	
	public boolean isSubTypeOf(Type anotherTypeAttribute) {
		if(theTypeName.equals(anotherTypeAttribute.theTypeName))
			return true;
		
		for (int i = 0; i < theParentTypes.length; i++) {
			Type parentType = theParentTypes[i];
			
			if(parentType.isSubTypeOf(anotherTypeAttribute))
				return true;
		}
		
		return false;
	}
	
	public void accept(AttributeVisitor theVisitor) {
		theVisitor.visit(this);
	}

	public AttributePicker makeAttributePicker(ExpressionList facts) {
		return UtilsFactory.ctePicker(this);
	}
	
	public String toString() {
		return theTypeName;
	}
	
	public Type[] getParentTypes() {
		return theParentTypes;
	}

}
