package edu.vub.crime.grammar.utils;

import edu.vub.crime.grammar.attributes.ConstantAttribute;
import edu.vub.crime.grammar.attributes.Attribute;
import edu.vub.crime.grammar.attributes.AttributeVisitor;
import edu.vub.crime.grammar.attributes.Variable;
import edu.vub.crime.grammar.attributes.datastructures.List;
import edu.vub.crime.grammar.attributes.datastructures.TypedObject;


public class PrintingVisitor extends AttributeVisitor {

	StringBuffer itsBuffer = new StringBuffer();
	boolean inTailPosition = false;
	
	public static String print(Attribute theAttribute) {
		PrintingVisitor thePrintingVisitor = new PrintingVisitor();
		
		theAttribute.accept(thePrintingVisitor);
		
		return thePrintingVisitor.itsBuffer.toString();
	}
	
	private PrintingVisitor() {
		super("print", " onto a stream");
	}
	
	public void visit(ConstantAttribute theConstant) {
		itsBuffer.append(theConstant.toString());
	}
	
	public void visit(Variable theVariable) {
		if(inTailPosition)
			itsBuffer.append('|');
		
		itsBuffer.append(theVariable.toString());
		
		if(inTailPosition)
			itsBuffer.append(']');
	}
	
	public void visit(List theList) {
		if(! inTailPosition) {
			itsBuffer.append('[');
		} 
		
		if(theList.isEmpty()) {
			itsBuffer.append(']');
		} else {
			if(inTailPosition)
				itsBuffer.append(',');
			
			inTailPosition = false;
			theList.getHead().accept(this);
			inTailPosition = true;
			theList.getTail().accept(this);
		}
	}
	
	public void visit(TypedObject theTypedObject) {
		itsBuffer.append(theTypedObject.toString());
	}
}
