package edu.vub.crime.grammar.utils;

import junit.framework.TestCase;
import edu.vub.crime.grammar.ExpressionFactory;
import edu.vub.crime.grammar.attributes.Variable;
import edu.vub.crime.grammar.attributes.constant.Type;
import edu.vub.crime.grammar.attributes.datastructures.TypedObject;

public class TypedObjectTest  extends TestCase {

	public void testObjectRepresentation() {
		Type		theCourseType	= ExpressionFactory.type("Course"); 
		TypedObject	theCourseObject	= new TypedObject(theCourseType);
		
		assertEquals("Course()", theCourseObject.toString());
		
		theCourseObject.addField(ExpressionFactory.pair("title", ExpressionFactory.attribute("Concepts of Programming Languages")));
		
		assertEquals("Course(title=\"Concepts of Programming Languages\")", theCourseObject.toString());
		
		theCourseObject.addField(ExpressionFactory.pair("tutor", ExpressionFactory.attribute("Theo D'Hondt")));
		theCourseObject.addField(ExpressionFactory.pair("curriculum", ExpressionFactory.attribute("Master in Applied Computer Science")));
		theCourseObject.addField(ExpressionFactory.pair("credits", ExpressionFactory.attribute(3)));
		
		assertEquals("Course(tutor=\"Theo D'Hondt\", curriculum=\"Master in Applied Computer Science\", credits=3, title=\"Concepts of Programming Languages\")", theCourseObject.toString());
	}
	
	public void testConsequentObject() {
		Variable	theGivenType	= ExpressionFactory.variable("type");
		TypedObject	theResultObject	= new TypedObject(theGivenType);
		
		assertEquals("?type()", theResultObject.toString());
	}
}

