package edu.vub.crime.grammar.utils;

import edu.vub.crime.grammar.ExpressionList;
import edu.vub.crime.grammar.attributes.Attribute;
import edu.vub.crime.grammar.attributes.Variable;
import edu.vub.crime.grammar.attributes.datastructures.List;
import edu.vub.crime.grammar.attributes.datastructures.Pair;
import edu.vub.crime.grammar.attributes.datastructures.RestVariable;
import edu.vub.crime.grammar.attributes.datastructures.TypedObject;

public class UtilsFactory {
	public static ActivationBuilder factBuilder(String kind) {
		return new ActivationBuilder(kind);
	}
	
	public static ConstantPicker ctePicker(Attribute attribute) {
		return new ConstantPicker(attribute);
	}
	
	public static VariablePicker varPicker(Variable theConsequentsVariable, int fNum, Variable theMatchingQueryVariable) {
		if (theConsequentsVariable instanceof RestVariable) {
			return new RestVariablePicker(fNum, theMatchingQueryVariable.getIndex());			
		}
		return new VariablePicker(fNum, theMatchingQueryVariable.getIndex());
	}
	
	public static ListPicker listPicker(ExpressionList facts, List list){
		return new ListPicker(facts, list);
	}
	
	public static ObjectPicker objectPicker(ExpressionList facts, TypedObject obj){
		return new ObjectPicker(facts, obj);
	}
	
	public static PairPicker pairPicker(ExpressionList facts, Pair pair){
		return new PairPicker(facts, pair);
	}
}
