package edu.vub.crime.grammar.utils;

import junit.framework.TestCase;
import edu.vub.crime.grammar.ExpressionFactory;
import edu.vub.crime.grammar.attributes.Attribute;

public class UtilsTest extends TestCase{
	
	public static void testCompare() {
		Attribute doubleOne = ExpressionFactory.attribute(1.0);
		Attribute doubleTwo = ExpressionFactory.attribute(1.1);
		
		Attribute symbolOne = ExpressionFactory.attribute("1.0");
		Attribute symbolTwo = ExpressionFactory.attribute("1.1");
		
		Attribute integerOne = ExpressionFactory.attribute(1);
		Attribute integerTwo = ExpressionFactory.attribute(2);
		
		
		//Simple tests
		assertFalse("Double error",doubleOne.equals(doubleTwo));
		assertTrue("Double error",doubleOne.equals(doubleOne));

		assertFalse("Symbol error",symbolOne.equals(symbolTwo));
		assertTrue("Symbol error",symbolOne.equals(symbolOne));
		
		assertFalse("Integer error",integerOne.equals(integerTwo));
		assertTrue("Integer error",integerOne.equals(integerOne));		
				
		//No automatic casts for symbol 
		assertFalse("Double vs Symbol",doubleOne.equals(symbolOne));
		
		//Cast for integer and double
		assertTrue("Cast int->double error",doubleOne.equals(integerOne));
		assertTrue("Cast double->int error",integerOne.equals(doubleOne));
		
	}
	
}
