package edu.vub.crime.network.m2mi;

import java.io.Serializable;

import edu.vub.crime.grammar.GenericFact;

/**
 * The NetworkInterface class specifies the M2MI-specific interface which can be invoked on a CRIME engine.
 *  
 * @author smostinc
 */
public interface NetworkInterface {

	/**
	 * Receive and schedule an activation from a given CRIME engine. 

	 * @param source an ID denoting the CRIME engine which published this activation
	 * @param tokens an activation to be scheduled in the agenda of this engine
	 */
	// public abstract void receiveActivation(Eoid source, Activation tokens);
	
	public abstract void assert(Serializable theSender, GenericFact theFact, int totalRetractsSoFar, int theAssertionsID);
	
	public abstract void retract(Serializable theSender, GenericFact theFact, int theRetractionsID, int totalAssertionsSoFar);

}