package edu.vub.crime.network.m2mi.sync;

import edu.rit.m2mi.Eoid;

public class AssertionGap extends SynchronisationState {
	
	private int theirTotalAssertions;
	
	public AssertionGap(SlidingWindow facts, Eoid device, int retract, int currentTotal, int desiredTotal) {
		super(facts, device, retract, currentTotal);
		
		theirTotalAssertions = desiredTotal;
	}
	
	public SynchronisationState beat(int retracted, int total) {
		if(itsRetractionCount < retracted) {
			return new DoubleGap(
					itsSlidingWindow, 
					itsDevice, 
					itsRetractionCount, 
					retracted, 
					itsAssertionCount,
					theirTotalAssertions >= total ? theirTotalAssertions : total);
		} else if(theirTotalAssertions < total) {
			theirTotalAssertions = total;
		}

		return this;
	}
	
	public SynchronisationState assert(String fact, int retracted, int total) {
		SynchronisationState theResult = this;
		
		if(itsAssertionCount <= total) {
			itsSlidingWindow.assert(fact, total);
			
			theirTotalAssertions = theirTotalAssertions > total ? theirTotalAssertions : total + 1;
			
			itsAssertionCount = itsSlidingWindow.findMissingAssertion(itsAssertionCount, theirTotalAssertions);
						
			if(itsAssertionCount == theirTotalAssertions) {
				theResult = 
					new NoGaps(itsSlidingWindow, itsDevice, itsRetractionCount, itsAssertionCount);
				
			}
		} /* else if(itsAssertionCount > total) */
		
		return theResult.beat(retracted, theirTotalAssertions);
	}
	
	public SynchronisationState retract(String fact, int retracted, int total) {
		if(itsRetractionCount  <   retracted) {
			SynchronisationState theResult = beat(retracted, total);
			
			return theResult.retract(fact, retracted, total);
		} else if(itsRetractionCount  ==  retracted) {
			itsSlidingWindow.retract(fact, itsRetractionCount++);
			
			return beat(retracted+1, total);
		} /* else if(itsRetractionCount  >  retracted) */
		
		return beat(itsRetractionCount, total);
	}
}
