package edu.vub.crime.network.m2mi.sync;

import java.util.HashMap;
import java.util.Map;

import edu.rit.m2mi.Eoid;

public class DoubleGap extends SynchronisationState {
	
	private int theirTotalRetractions;
	private int theirTotalAssertions;

	private Map itsAntiAssertions;
	
	public DoubleGap(SlidingWindow facts, Eoid device, int currentRetracted, int totalRetracted, int currentTotal, int desiredTotal) {
		super(facts, device, currentRetracted, currentTotal);
		
		theirTotalRetractions = totalRetracted;
		theirTotalAssertions = desiredTotal;
		
		itsAntiAssertions = new HashMap();
	}
	
	public SynchronisationState beat(int retracted, int total) {
		theirTotalRetractions = 
			theirTotalRetractions > retracted ? 
					theirTotalRetractions : 
					retracted;
		theirTotalAssertions = 
			theirTotalAssertions > total ?
					theirTotalAssertions : 
					total;
		
		return this;
	}
	
	public SynchronisationState assert(String fact, int retracted, int total) {
		SynchronisationState theResult = this;
		
		theirTotalRetractions = theirTotalRetractions > retracted ? theirTotalRetractions : retracted;

		if(itsAssertionCount <= total) {
			itsSlidingWindow.assert(fact, total);
			
			theirTotalAssertions = theirTotalAssertions > total ? theirTotalAssertions : total + 1;

			itsAssertionCount = itsSlidingWindow.findMissingAssertion(itsAssertionCount, theirTotalAssertions);
						
			if(itsAssertionCount == theirTotalAssertions) {
				theResult = 
					new RetractionGap(itsSlidingWindow, itsDevice, itsRetractionCount, theirTotalRetractions, itsAssertionCount);
				
			}
		} /* else if(itsAssertionCount > total) */
		
		Integer theRetractionId = (Integer)itsAntiAssertions.get(fact);
		
		if(theRetractionId != null) {
			return theResult.retract(fact, theRetractionId.intValue(), theirTotalAssertions);
		}
		
		return theResult;
	}
	
	public SynchronisationState retract(String fact, int retracted, int total) {
		SynchronisationState theResult = this;
		
		theirTotalAssertions = theirTotalAssertions > total ? theirTotalAssertions : total;

		if(itsRetractionCount <= retracted) {
			boolean wasPresent = itsSlidingWindow.retract(fact, retracted);
			
			theirTotalRetractions = theirTotalRetractions > retracted ? theirTotalRetractions : retracted + 1;
			
			itsRetractionCount = itsSlidingWindow.findMissingRetraction(itsRetractionCount, theirTotalRetractions);
						
			if(! wasPresent) {
				itsAntiAssertions.put(fact, new Integer(retracted));
				
			} else if(itsRetractionCount == theirTotalRetractions) {	
				theResult = 
					new AssertionGap(itsSlidingWindow, itsDevice, itsRetractionCount, itsAssertionCount, theirTotalAssertions);
			}
		} /* else if(itsRetractionCount > retracted) */
		
		return theResult;
	}
}

