package edu.vub.crime.network.m2mi.sync;

import edu.rit.m2mi.Eoid;

public class NoGaps extends SynchronisationState {
	
	public NoGaps(SlidingWindow facts, Eoid device, int retract, int total) {
		super(facts, device, retract, total);
	}
	
	public SynchronisationState beat(int retracted, int total) {
		if(itsRetractionCount < retracted && itsAssertionCount < total) {
			return new DoubleGap(itsSlidingWindow, itsDevice, itsRetractionCount, retracted, itsAssertionCount, total);
		} else if(itsRetractionCount < retracted) {
			return new RetractionGap(itsSlidingWindow, itsDevice, itsRetractionCount, retracted, itsAssertionCount);
		} else if(itsAssertionCount < total) {
			return new AssertionGap(itsSlidingWindow, itsDevice, itsRetractionCount, itsAssertionCount, total);
		}
		
		return this;
	}
	
	public SynchronisationState assert(String fact, int retracted, int total) {
		if(itsAssertionCount  <   total) {
			SynchronisationState theResult = beat(retracted, total);
			
			return theResult.assert(fact, retracted, total);
		} else if(itsAssertionCount  ==  total) {
			itsSlidingWindow.assert(fact, itsAssertionCount++);
			
			return beat(retracted, total+1);
		} /* else if(itsAssertionCount  >  total) */
		
		return beat(retracted, itsAssertionCount);
	}
	
	public SynchronisationState retract(String fact, int retracted, int total) {
		if(itsRetractionCount  <   retracted) {
			SynchronisationState theResult = beat(retracted, total);
			
			return theResult.retract(fact, retracted, total);
		} else if(itsRetractionCount  ==  retracted) {
			itsSlidingWindow.retract(fact, itsRetractionCount++);
			
			return beat(retracted+1, total);
		} /* else if(itsRetractionCount  >  retracted) */
		
		return beat(itsRetractionCount, total);
	}
}
