package edu.vub.crime.network.m2mi.sync;

import edu.rit.m2mi.Eoid;

public class RetractionGap extends SynchronisationState {
	
	private int theirTotalRetractions;
	
	public RetractionGap(SlidingWindow facts, Eoid device, int currentRetracted, int totalRetracted, int total) {
		super(facts, device, currentRetracted, total);
		
		theirTotalRetractions = totalRetracted;
	}
	
	public SynchronisationState beat(int retracted, int total) {
		if(itsAssertionCount < total) {
			return new DoubleGap(
					itsSlidingWindow, 
					itsDevice, 
					itsRetractionCount, 
					theirTotalRetractions >= retracted ? theirTotalRetractions : retracted, 
					itsAssertionCount,
					total);
		} else if(theirTotalRetractions < retracted) {
			theirTotalRetractions = retracted;
		}

		return this;
	}
	
	public SynchronisationState assert(String fact, int retracted, int total) {
		if(itsAssertionCount  <   total) {
			SynchronisationState theResult = beat(retracted, total);
			
			return theResult.assert(fact, retracted, total);
		} else if(itsAssertionCount  ==  total) {
			itsSlidingWindow.assert(fact, itsAssertionCount++);
			
			return beat(retracted, total+1);
		} /* else if(itsAssertionCount  >  total) */
		
		return beat(retracted, itsAssertionCount);
	}

	public SynchronisationState retract(String fact, int retracted, int total) {
		SynchronisationState theResult = this;
		
		if(itsRetractionCount <= retracted) {
			itsSlidingWindow.retract(fact, retracted);
			
			theirTotalRetractions = theirTotalRetractions > retracted ? theirTotalRetractions : retracted + 1;
			
			itsRetractionCount = itsSlidingWindow.findMissingRetraction(itsRetractionCount, theirTotalRetractions);
						
			if(itsRetractionCount == theirTotalRetractions) {
				theResult = 
					new NoGaps(itsSlidingWindow, itsDevice, itsRetractionCount, itsAssertionCount);
				
			}
		} /* else if(itsRetractionCount > retracted) */
		
		return theResult.beat(theirTotalRetractions, total);
	}
	
}
