package edu.vub.crime.parser;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import antlr.CommonAST;
import edu.vub.crime.grammar.ExpressionList;

public class CrimeParser {

	public static ExpressionList parseConditions(String input) {
        try {
            LexerImpl lexer = new LexerImpl(new ByteArrayInputStream(input.getBytes()));
            ParserImpl parser = new ParserImpl(lexer);
            // Parse the input expression
            parser.pattern_list();
            CommonAST t = (CommonAST)parser.getAST();
            TreeWalkerImpl walker = new TreeWalkerImpl();
            ExpressionList conditions = walker.pattern_list(t);
            
            return conditions;
        } catch(Exception e) {
        	e.printStackTrace();
        	throw new RuntimeException("Exception: " + e.getMessage());
        }
	}
	
	public static ExpressionList parse(String input) {
		return parse(new ByteArrayInputStream(input.getBytes()));
	}
	
	public static ExpressionList parse(InputStream input) {
	        try {
            LexerImpl lexer = new LexerImpl(input);
            ParserImpl parser = new ParserImpl(lexer);
            // Parse the input expression
            parser.program();
            CommonAST t = (CommonAST)parser.getAST();
            TreeWalkerImpl walker = new TreeWalkerImpl();
            ExpressionList program = walker.program(t);
            
            return program;
        } catch(Exception e) {
        	e.printStackTrace();
        	throw new RuntimeException("Exception: " + e.getMessage());
        }
	}
}
