// $ANTLR : "crime.g" -> "TreeWalkerImpl.java"$
package edu.vub.crime.parser;
import antlr.TreeParser;
import antlr.Token;
import antlr.collections.AST;
import antlr.RecognitionException;
import antlr.ANTLRException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.collections.impl.BitSet;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;
	
	import edu.vub.crime.grammar.*;
	import edu.vub.crime.grammar.attributes.*;
	import edu.vub.crime.grammar.attributes.constant.*;
	import edu.vub.crime.grammar.attributes.datastructures.*;

	import java.util.Vector;


public class TreeWalkerImpl extends antlr.TreeParser       implements ParserImplTokenTypes
 {
public TreeWalkerImpl() {
	tokenNames = _tokenNames;
}

	public final  ExpressionList  program(AST _t) throws RecognitionException, CrimeParseException {
		 ExpressionList expressions ;
		
		AST program_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
				expressions = new ExpressionList();
			
		
		try {      // for error handling
			AST __t143 = _t;
			AST tmp44_AST_in = (AST)_t;
			match(_t,AGPROG);
			_t = _t.getFirstChild();
			{
			_loop145:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_tokenSet_0.member(_t.getType()))) {
					statement_or_expression(_t,expressions);
					_t = _retTree;
				}
				else {
					break _loop145;
				}
				
			} while (true);
			}
			_t = __t143;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return expressions ;
	}
	
	public final void statement_or_expression(AST _t,
		 ExpressionList expressions 
	) throws RecognitionException, CrimeParseException {
		
		AST statement_or_expression_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
				String package_name, short_name, full_name, child, aParent;
				Vector allParents = new Vector();
				Expression expr;
			
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case AGPACK:
			{
				AST __t147 = _t;
				AST tmp45_AST_in = (AST)_t;
				match(_t,AGPACK);
				_t = _t.getFirstChild();
				package_name=indexed_name(_t);
				_t = _retTree;
				_t = __t147;
				_t = _t.getNextSibling();
					ExpressionFactory.setPackage(package_name);
				break;
			}
			case AGABBR:
			{
				AST __t148 = _t;
				AST tmp46_AST_in = (AST)_t;
				match(_t,AGABBR);
				_t = _t.getFirstChild();
				short_name=indexed_name(_t);
				_t = _retTree;
				full_name=indexed_name(_t);
				_t = _retTree;
				_t = __t148;
				_t = _t.getNextSibling();
					ExpressionFactory.registerAbbreviation(short_name, full_name);
				break;
			}
			case AGEXTS:
			{
				AST __t149 = _t;
				AST tmp47_AST_in = (AST)_t;
				match(_t,AGEXTS);
				_t = _t.getFirstChild();
				child=type_name(_t);
				_t = _retTree;
				{
				int _cnt151=0;
				_loop151:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_t.getType()==AGTYPE)) {
						aParent=type_name(_t);
						_t = _retTree;
							allParents.add(ExpressionFactory.type(aParent));
					}
					else {
						if ( _cnt151>=1 ) { break _loop151; } else {throw new NoViableAltException(_t);}
					}
					
					_cnt151++;
				} while (true);
				}
				_t = __t149;
				_t = _t.getNextSibling();
				
								Type[] theParents = (Type[]) allParents.toArray(new Type[ allParents.size() ]);
								ExpressionFactory.registerSubtypeRelationship(child, theParents);
							
				break;
			}
			case AGASRT:
			case AGRULE:
			{
				expr=expression(_t);
				_t = _retTree;
				expressions.add( expr );
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final  String  indexed_name(AST _t) throws RecognitionException {
		 String theName ;
		
		AST indexed_name_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST next = null;
		
					 			theName 		= null;
				StringBuffer 	theFullName		= new StringBuffer();
			
		
		try {      // for error handling
			{
			int _cnt203=0;
			_loop203:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==NAM)) {
					next = (AST)_t;
					match(_t,NAM);
					_t = _t.getNextSibling();
						String 	theConstituent	= next.getText();
										
										if(theFullName.length() != 0)
											theFullName.append(".");
										
										theFullName.append(theConstituent);
									
				}
				else {
					if ( _cnt203>=1 ) { break _loop203; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt203++;
			} while (true);
			}
				theName = theFullName.toString();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return theName ;
	}
	
	public final  String  type_name(AST _t) throws RecognitionException {
		 String type ;
		
		AST type_name_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST txt = null;
			
				type = null; 
			
		
		try {      // for error handling
			AST __t200 = _t;
			AST tmp48_AST_in = (AST)_t;
			match(_t,AGTYPE);
			_t = _t.getFirstChild();
			txt = (AST)_t;
			match(_t,NAM);
			_t = _t.getNextSibling();
			_t = __t200;
			_t = _t.getNextSibling();
			type = txt.getText();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return type ;
	}
	
	public final  Expression  expression(AST _t) throws RecognitionException, CrimeParseException {
		 Expression expr ;
		
		AST expression_AST_in = (_t == ASTNULL) ? null : (AST)_t;
			expr = null;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case AGASRT:
			{
				expr=assertion(_t);
				_t = _retTree;
				break;
			}
			case AGRULE:
			{
				expr=rule(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return expr ;
	}
	
	public final  Expression  assertion(AST _t) throws RecognitionException, CrimeParseException {
		 Expression expr ;
		
		AST assertion_AST_in = (_t == ASTNULL) ? null : (AST)_t;
			expr = null;
		
		try {      // for error handling
			AST __t154 = _t;
			AST tmp49_AST_in = (AST)_t;
			match(_t,AGASRT);
			_t = _t.getFirstChild();
			expr=fact(_t);
			_t = _retTree;
			_t = __t154;
			_t = _t.getNextSibling();
				if(! expr.variables().isEmpty())
								throw new CrimeParseException("Asserted facts may never contain variables");
						
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return expr ;
	}
	
	public final  Expression  rule(AST _t) throws RecognitionException, CrimeParseException {
		 Expression expr ;
		
		AST rule_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
				expr = null;
				ExpressionList effects;
				ExpressionList prerequisites; 
			
		
		try {      // for error handling
			AST __t156 = _t;
			AST tmp50_AST_in = (AST)_t;
			match(_t,AGRULE);
			_t = _t.getFirstChild();
			effects=effect_list(_t);
			_t = _retTree;
			AST __t157 = _t;
			AST tmp51_AST_in = (AST)_t;
			match(_t,AGCOND);
			_t = _t.getFirstChild();
			prerequisites=pattern_list(_t);
			_t = _retTree;
			_t = __t157;
			_t = _t.getNextSibling();
			_t = __t156;
			_t = _t.getNextSibling();
							  				  	
						  	if( prerequisites.variables().containsAll( effects.variables() )) {
						  		RuleConsequenceVisitor theVisitor = new RuleConsequenceVisitor();
						  		
						  		effects.accept(theVisitor);
			
						  		expr = ExpressionFactory.rule(theVisitor.getEvents(), prerequisites);
						  	} else {
						  		//Warning effect variables are mutated !!
						  		effects.variables().removeAll(prerequisites.variables());
						  		throw new CrimeParseException("Effect of a rule contains unbound variables "+ effects.variables());
						  	}
						
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return expr ;
	}
	
	public final  GenericFact  fact(AST _t) throws RecognitionException {
		 GenericFact aFact ;
		
		AST fact_AST_in = (_t == ASTNULL) ? null : (AST)_t;
			
				aFact = null;
				String name, space;
			
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case AGQUA:
			{
				AST __t173 = _t;
				AST tmp52_AST_in = (AST)_t;
				match(_t,AGQUA);
				_t = _t.getFirstChild();
				space=type_name(_t);
				_t = _retTree;
				name=type_name(_t);
				_t = _retTree;
					aFact = ExpressionFactory.qualifiedFact(space, name);
				attributes(_t, aFact );
				_t = _retTree;
				_t = __t173;
				_t = _t.getNextSibling();
				break;
			}
			case AGUNQ:
			{
				AST __t174 = _t;
				AST tmp53_AST_in = (AST)_t;
				match(_t,AGUNQ);
				_t = _t.getFirstChild();
				name=type_name(_t);
				_t = _retTree;
					aFact = ExpressionFactory.unqualifiedFact(name);
				attributes(_t,aFact);
				_t = _retTree;
				_t = __t174;
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return aFact ;
	}
	
	public final ExpressionList  effect_list(AST _t) throws RecognitionException {
		ExpressionList effects;
		
		AST effect_list_AST_in = (_t == ASTNULL) ? null : (AST)_t;
			
							effects = new ExpressionList();
				Expression	expr  = null;
			
		
		try {      // for error handling
			{
			int _cnt160=0;
			_loop160:
			do {
				if (_t==null) _t=ASTNULL;
				if (((_t.getType() >= AGQUA && _t.getType() <= AGEVNT))) {
					expr=effect(_t);
					_t = _retTree;
					effects.add(expr);
				}
				else {
					if ( _cnt160>=1 ) { break _loop160; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt160++;
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return effects;
	}
	
	public final  ExpressionList  pattern_list(AST _t) throws RecognitionException, CrimeParseException {
		 ExpressionList patterns ;
		
		AST pattern_list_AST_in = (_t == ASTNULL) ? null : (AST)_t;
			
				patterns = new ExpressionList(); 
				Expression expr;
			
		
		try {      // for error handling
			{
			_loop166:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_tokenSet_1.member(_t.getType()))) {
					expr=pattern(_t);
					_t = _retTree;
					if(expr instanceof Property)
																	patterns.addProperty( (Property)expr );
																else
																	patterns.add( expr );
				}
				else {
					break _loop166;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return patterns ;
	}
	
	public final  AttributedExpression  effect(AST _t) throws RecognitionException {
		 AttributedExpression expr ;
		
		AST effect_AST_in = (_t == ASTNULL) ? null : (AST)_t;
			
				expr = null;
				String name; 
			
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case AGQUA:
			case AGUNQ:
			{
				expr=fact(_t);
				_t = _retTree;
				break;
			}
			case AGEVNT:
			{
				AST __t162 = _t;
				AST tmp54_AST_in = (AST)_t;
				match(_t,AGEVNT);
				_t = _t.getFirstChild();
				AST __t163 = _t;
				AST tmp55_AST_in = (AST)_t;
				match(_t,AGEVNT);
				_t = _t.getFirstChild();
				name=indexed_name(_t);
				_t = _retTree;
				_t = __t163;
				_t = _t.getNextSibling();
					expr = ExpressionFactory.event(name);
				attributes(_t,expr);
				_t = _retTree;
				_t = __t162;
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return expr ;
	}
	
	public final void attributes(AST _t,
		 AttributedExpression fact_or_event 
	) throws RecognitionException {
		
		AST attributes_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
				Pair theAttribute;
				IndexingVisitor indx = new IndexingVisitor(fact_or_event);
			
		
		try {      // for error handling
			{
			_loop177:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==AGPAIR)) {
					theAttribute=pair(_t);
					_t = _retTree;
					indx.nextAttribute(theAttribute.getName(), theAttribute.getValue());
				}
				else {
					break _loop177;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final  Expression  pattern(AST _t) throws RecognitionException, CrimeParseException {
		 Expression pattern ;
		
		AST pattern_AST_in = (_t == ASTNULL) ? null : (AST)_t;
			
				pattern = null;
				
				GenericFact		negatedFact;
				
				Variable 		accumulatedVar, 
								collectionVar;
				ExpressionList	query;
				
				Attribute		listAttribute,
								lengthAttribute;
			
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case AGQUA:
			case AGUNQ:
			{
				pattern=fact(_t);
				_t = _retTree;
				break;
			}
			case AGNOT:
			{
				AST __t168 = _t;
				AST tmp56_AST_in = (AST)_t;
				match(_t,AGNOT);
				_t = _t.getFirstChild();
				negatedFact=fact(_t);
				_t = _retTree;
				_t = __t168;
				_t = _t.getNextSibling();
					pattern = ExpressionFactory.negation(negatedFact);	
				break;
			}
			case AGFNDA:
			{
				AST __t169 = _t;
				AST tmp57_AST_in = (AST)_t;
				match(_t,AGFNDA);
				_t = _t.getFirstChild();
				accumulatedVar=simple_variable(_t);
				_t = _retTree;
				query=pattern_list(_t);
				_t = _retTree;
				collectionVar=simple_variable(_t);
				_t = _retTree;
				_t = __t169;
				_t = _t.getNextSibling();
					pattern = ExpressionFactory.findAll(accumulatedVar, query, collectionVar);
				break;
			}
			case AGBGOF:
			{
				AST __t170 = _t;
				AST tmp58_AST_in = (AST)_t;
				match(_t,AGBGOF);
				_t = _t.getFirstChild();
				accumulatedVar=simple_variable(_t);
				_t = _retTree;
				query=pattern_list(_t);
				_t = _retTree;
				collectionVar=simple_variable(_t);
				_t = _retTree;
				_t = __t170;
				_t = _t.getNextSibling();
					pattern = ExpressionFactory.bagOf(accumulatedVar, query, collectionVar);
				break;
			}
			case AGLEN:
			{
				AST __t171 = _t;
				AST tmp59_AST_in = (AST)_t;
				match(_t,AGLEN);
				_t = _t.getFirstChild();
				listAttribute=attribute(_t);
				_t = _retTree;
				lengthAttribute=attribute(_t);
				_t = _retTree;
				_t = __t171;
				_t = _t.getNextSibling();
					pattern = ExpressionFactory.length(listAttribute,lengthAttribute);
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return pattern ;
	}
	
	public final  Variable  simple_variable(AST _t) throws RecognitionException {
		 Variable var ;
		
		AST simple_variable_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST txt = null;
			var = null;
		
		try {      // for error handling
			AST __t205 = _t;
			AST tmp60_AST_in = (AST)_t;
			match(_t,AGVAR);
			_t = _t.getFirstChild();
			txt = (AST)_t;
			match(_t,NAM);
			_t = _t.getNextSibling();
			_t = __t205;
			_t = _t.getNextSibling();
			var = ExpressionFactory.variable(txt.getText());
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return var ;
	}
	
	public final  Attribute  attribute(AST _t) throws RecognitionException {
		 Attribute attr ;
		
		AST attribute_AST_in = (_t == ASTNULL) ? null : (AST)_t;
			
				attr = null;
			
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case AGTYPE:
			case AGNBR:
			case AGFRC:
			case AGTXT:
			case AGSYM:
			{
				attr=literal(_t);
				_t = _retTree;
				break;
			}
			case AGVAR:
			{
				attr=simple_variable(_t);
				_t = _retTree;
				break;
			}
			case AGLST:
			case AGNIL:
			{
				attr=list(_t);
				_t = _retTree;
				break;
			}
			case AGOBJ:
			{
				attr=object(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return attr ;
	}
	
	public final  Pair  pair(AST _t) throws RecognitionException {
		 Pair thePair ;
		
		AST pair_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST op = null;
		
							thePair			= null;
				String		theFieldName	= null;
				Operator 	theOperator		= null;
				Attribute	theFieldValue	= null;
			
		
		try {      // for error handling
			AST __t184 = _t;
			AST tmp61_AST_in = (AST)_t;
			match(_t,AGPAIR);
			_t = _t.getFirstChild();
			theFieldName=name(_t);
			_t = _retTree;
			AST __t185 = _t;
			AST tmp62_AST_in = (AST)_t;
			match(_t,AGCMP);
			_t = _t.getFirstChild();
			op = (AST)_t;
			match(_t,RELATIONAL_OPERATOR);
			_t = _t.getNextSibling();
			_t = __t185;
			_t = _t.getNextSibling();
			theFieldValue=attribute(_t);
			_t = _retTree;
			_t = __t184;
			_t = _t.getNextSibling();
				theOperator = Operator.getOperator(op.getText());
							// 
							if(theOperator != Operator.EQL && theOperator != Operator.NEQ)
								if(	!(theFieldValue instanceof edu.vub.crime.grammar.attributes.constant.Number) && 
									!(theFieldValue instanceof edu.vub.crime.grammar.attributes.constant.Fraction) && 
									!(theFieldValue instanceof edu.vub.crime.grammar.attributes.Variable))
									throw new RuntimeException("Cannot compare non-numeric attributes other than for (non-)equality");
							thePair = ExpressionFactory.pair(theFieldName, theOperator, theFieldValue);
						
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return thePair ;
	}
	
	public final  Attribute  literal(AST _t) throws RecognitionException {
		 Attribute lit;
		
		AST literal_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST nbr = null;
		AST frc = null;
		AST txt = null;
		AST sym = null;
		
				lit = null;
			
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case AGNBR:
			{
				AST __t195 = _t;
				AST tmp63_AST_in = (AST)_t;
				match(_t,AGNBR);
				_t = _t.getFirstChild();
				nbr = (AST)_t;
				match(_t,NBR);
				_t = _t.getNextSibling();
				_t = __t195;
				_t = _t.getNextSibling();
				lit = ExpressionFactory.attribute(Integer.parseInt(nbr.getText()));
				break;
			}
			case AGFRC:
			{
				AST __t196 = _t;
				AST tmp64_AST_in = (AST)_t;
				match(_t,AGFRC);
				_t = _t.getFirstChild();
				frc = (AST)_t;
				match(_t,FRC);
				_t = _t.getNextSibling();
				_t = __t196;
				_t = _t.getNextSibling();
				lit = ExpressionFactory.attribute(Double.parseDouble(frc.getText()));
				break;
			}
			case AGTXT:
			{
				AST __t197 = _t;
				AST tmp65_AST_in = (AST)_t;
				match(_t,AGTXT);
				_t = _t.getFirstChild();
				txt = (AST)_t;
				match(_t,TXT);
				_t = _t.getNextSibling();
				_t = __t197;
				_t = _t.getNextSibling();
				String text = txt.getText(); lit = ExpressionFactory.attribute(text.substring(1, text.length() - 1));
				break;
			}
			case AGSYM:
			{
				AST __t198 = _t;
				AST tmp66_AST_in = (AST)_t;
				match(_t,AGSYM);
				_t = _t.getFirstChild();
				sym = (AST)_t;
				match(_t,NAM);
				_t = _t.getNextSibling();
				_t = __t198;
				_t = _t.getNextSibling();
				lit = ExpressionFactory.symbol(sym.getText());
				break;
			}
			case AGTYPE:
			{
					String type;
				type=type_name(_t);
				_t = _retTree;
				lit = ExpressionFactory.type(type);
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return lit;
	}
	
	public final  List  list(AST _t) throws RecognitionException {
		 List theList ;
		
		AST list_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
							theList = ExpressionFactory.list();
				Attribute	theListElement;
				Attribute	theListTail;
			
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case AGLST:
			{
				AST __t187 = _t;
				AST tmp67_AST_in = (AST)_t;
				match(_t,AGLST);
				_t = _t.getFirstChild();
				{
				int _cnt189=0;
				_loop189:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_tokenSet_2.member(_t.getType()))) {
						theListElement=attribute(_t);
						_t = _retTree;
							theList.add( theListElement );
					}
					else {
						if ( _cnt189>=1 ) { break _loop189; } else {throw new NoViableAltException(_t);}
					}
					
					_cnt189++;
				} while (true);
				}
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case AGTAIL:
				{
					AST __t191 = _t;
					AST tmp68_AST_in = (AST)_t;
					match(_t,AGTAIL);
					_t = _t.getFirstChild();
					{
					theListTail=attribute(_t);
					_t = _retTree;
						theList.setTail( theListTail );
					}
					_t = __t191;
					_t = _t.getNextSibling();
					break;
				}
				case 3:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				_t = __t187;
				_t = _t.getNextSibling();
				break;
			}
			case AGNIL:
			{
				AST __t193 = _t;
				AST tmp69_AST_in = (AST)_t;
				match(_t,AGNIL);
				_t = _t.getFirstChild();
				AST tmp70_AST_in = (AST)_t;
				match(_t,AGLST);
				_t = _t.getNextSibling();
				_t = __t193;
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return theList ;
	}
	
	public final  TypedObject  object(AST _t) throws RecognitionException {
		 TypedObject theObject ;
		
		AST object_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
							theObject = null;
				Attribute 	theType;
				Pair 		theField;
			
		
		try {      // for error handling
			AST __t180 = _t;
			AST tmp71_AST_in = (AST)_t;
			match(_t,AGOBJ);
			_t = _t.getFirstChild();
			theType=literal(_t);
			_t = _retTree;
				theObject = ExpressionFactory.object(theType);
			{
			_loop182:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==AGPAIR)) {
					theField=pair(_t);
					_t = _retTree;
						theObject.addField ( theField );
				}
				else {
					break _loop182;
				}
				
			} while (true);
			}
			_t = __t180;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return theObject ;
	}
	
	public final  String  name(AST _t) throws RecognitionException {
		 String n ;
		
		AST name_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST txt = null;
			
				n = null; 
			
		
		try {      // for error handling
			AST __t207 = _t;
			AST tmp72_AST_in = (AST)_t;
			match(_t,AGNAME);
			_t = _t.getFirstChild();
			txt = (AST)_t;
			match(_t,NAM);
			_t = _t.getNextSibling();
			_t = __t207;
			_t = _t.getNextSibling();
			n = txt.getText();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return n ;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"package\"",
		"\"action\"",
		"\"is\"",
		"\"type\"",
		"\"extends\"",
		"COLON",
		"DOT",
		"INFERS",
		"COMMA",
		"ARROW",
		"a left parenthesis",
		"a right parenthesis",
		"\"findall\"",
		"\"bagof\"",
		"\"length\"",
		"\"not\"",
		"RELATIONAL_OPERATOR",
		"a left bracket",
		"a right bracket",
		"PIP",
		"NBR",
		"FRC",
		"a text string",
		"a symbol",
		"QUESTION",
		"BQU",
		"AGPROG",
		"AGPACK",
		"AGABBR",
		"AGTYPE",
		"AGEXTS",
		"AGNOT",
		"AGNULL",
		"AGFNDA",
		"AGBGOF",
		"AGLEN",
		"AGASRT",
		"AGRULE",
		"AGCOND",
		"AGXCON",
		"AGQUA",
		"AGUNQ",
		"AGEVNT",
		"AGLST",
		"AGNIL",
		"AGTAIL",
		"AGOBJ",
		"AGPAIR",
		"AGNAME",
		"AGVAR",
		"AGNBR",
		"AGFRC",
		"AGTXT",
		"AGSYM",
		"AGCMP",
		"AGADD",
		"AGMUL",
		"AGPOW",
		"DIGIT",
		"LETTER",
		"EXPONENT",
		"CMPCHAR",
		"SIGN",
		"SCALE",
		"COLON_OR_INFERS",
		"a number or fraction",
		"CMP",
		"whitespace",
		"newline",
		"a single-line comment",
		"a multi-line comment",
		"ESC"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 3322157203456L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 53772990545920L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 280771297858813952L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	}
	
