package edu.vub.crime.rete.agenda;

import java.util.Iterator;
import java.util.LinkedList;

public class LIFOAgenda extends Agenda {

	private LinkedList itsActivations= new LinkedList();
	
	public void schedule(Activation theActivation) {
		synchronized (itsActivations) {
			if(! checkForConflicts(theActivation)) {
				itsActivations.addFirst(theActivation);
				itsActivations.notify();
			}
		}
	}
	
	public Activation getNextActivation() throws InterruptedException {
		synchronized (itsActivations) {
			while(itsActivations.isEmpty()) {
				if(askedToClose)
					throw new InterruptedException();
				
				itsActivations.wait();
			} 
			
			return (Activation) itsActivations.removeFirst(); 
		}
	}
	
	public Activation pollForActivation() {
		synchronized (itsActivations) {
			if(! itsActivations.isEmpty())
				return (Activation)itsActivations.removeFirst();
			
			return null;
		}
	}

	protected Iterator iterator() {
		return itsActivations.iterator();
	}

    public boolean hasNext() {
    	return 
    		super.hasNext() ||
    		! itsActivations.isEmpty();
    }
    
    
    public void close() {
    	synchronized (itsActivations) {
    		super.close();
    		
			itsActivations.notify();
		}
    }
    
    public int size() {
    	return itsActivations.size();
    }
}
