package edu.vub.crime.rete.data;

/** <pre>
 * A TokenTag is used to determine how the memories of the JoinNodes
 * in the Rete network need to be updated.
 * There are two kind of tags, namely add and remove.
 * Add will cause the addition of a token in the memory of the JoinNode,
 * whereas the removal of a token is caused when a token wit a TokenTag equal
 * to remove is inserted in the JoinNode.
 * </pre> */
public class TokenTag {

	public static final int remove 			= -1;
	public static final int add 			= 1;
	public static final int unconditional 	= 2;
	
	public static boolean areComplementary(int tag1, int tag2) {
		return ((tag1 + tag2) == 0);
	}
}