package edu.vub.crime.rete.nodes;

import edu.vub.crime.CrimeEngine;
import edu.vub.crime.grammar.Rule;
import edu.vub.crime.grammar.utils.AttributePicker;
import edu.vub.crime.rete.combiner.Combiner;

public class NodesFactory {
	
	static public FilterNode filterNode() {
		return new FilterNode();
	}
	
	static public JoinNode joinNode(Combiner c) {
		return new JoinNode(c);
	}	
	
	static public RootNode rootNode() {
		return new RootNode();
	}
	
	static public ProductionNode productionNode(Rule rule, CrimeEngine engine) {
		return new ProductionNode(rule,engine);
	}

	static public FindallNode findallNode(AttributePicker pck, int prev) {
		return new FindallNode(pck, prev);
	}
	
	static public BagofNode bagofNode() {
		return new BagofNode();
	}
	
	static public LengthNode lengthNode(boolean isLengthBound, AttributePicker theListPicker, AttributePicker possiblyTheLengthPicker) {
		return new LengthNode(isLengthBound, theListPicker, possiblyTheLengthPicker);
	}
	
	static public NegationFilterNode negationFilterNode() {
		return new NegationFilterNode();
	}
}
