package edu.vub.crime.rete.nodes.aux;

import java.util.Iterator;
import java.util.Vector;

import junit.framework.Assert;
import edu.vub.crime.rete.data.Token;
import edu.vub.crime.rete.data.TokenTag;
import edu.vub.crime.rete.nodes.Node;

public class TestNode extends Node {

	public Vector itsTokens;
	
	public TestNode() {
		this.itsTokens = new Vector();
	}
	
	public void reset() {
		itsTokens.clear();
	}
	
	public void assertTriggered(boolean expected) {
		boolean wasTriggered = (itsTokens.size() > 0);
		
		Assert.assertEquals(expected, wasTriggered);
	}
	
	public void assertTriggered(int expectedTokenTag) {
		Assert.assertTrue(itsTokens.size() == 1);
		Token theToken = (Token)itsTokens.get(0);
		
		Assert.assertEquals(expectedTokenTag, theToken.getTag());
	}
	
	public void assertTriggered(int expectedAssertions, int expectedRetractions) {
		int actualAssertions	= 0;
		int actualRetractions	= 0;
		
		for (Iterator tokenIt = itsTokens.iterator(); tokenIt.hasNext();) {
			Token currentToken = (Token) tokenIt.next();
			
			switch (currentToken.getTag()) {
				case TokenTag.add:
					actualAssertions++;
					break;
				case TokenTag.remove:
					actualRetractions++;
					break;
			}
		}
		
		Assert.assertEquals(expectedAssertions, actualAssertions);
		Assert.assertEquals(expectedRetractions, actualRetractions);
	}
	
	public void insert(Token token) {
		this.itsTokens.add(token);		
	}
}
